/**************************************************
						   
  game.h

  The game class for the konnect4 program.
  Gihan Marasingha
  1st January 2000
  
**************************************************/

#ifndef __GAME__
#define __GAME__

#include "grid.h"
#include <string.h>

class game
{
private:
  enum { ing=1, outg=2};
  int width, height; // width and height of the grid
  int ingame; // is ing if we're in the game, else it's outg.
  int bell; // should we ring the system bell?
  int sock; // the file descriptor of the socket.
  grid *mygrid; // holds the konnect4 grid
  int portno; // the port number.
  int myscore, hisscore; // the scores of this player
  // and the opposing player.
  char myname[80], hisname[80]; // the name of this player.
  char mytoken, histoken; // tokens which represent
  // this player and the enemy.
  void swrite(const char *); // writes data to the socket.
  int sread(char *); // reads data from the socket,
                     // returns the number of bytes read. 
  int wait(void); // wait for response from opponent,
                  // returns the column number.
  void setwidth(char *); 
  void setheight(char *);
  void connect(char *);
  void listen(void);
  void port(char *);
  void score(void);
  void name(char *);
  void end(void);
  void print(void);
  void help(void);
  void rules(void);
  void setbell(char *);
public:
  game();
  void command(int i,char *str);
  int running(void) { return ingame; }
  void number(int);
};

#endif __GAME__

















